/*
   Programm, das alle Kommentare aus C-Programm eliminiert.

   Interpretation der Zustaende:
     S0   Startzustand
     S1   moegliches erstes '/' gelesen
     S2   innerhalb des Kommentars
     S3   moegliches Kommentarende
*/

#include <stdio.h>

void
error(void)
{
  printf("Dateiende innerhalb eines Kommentars!\n");
  exit(0);
}

int
main(void)
{
  int state;
  char c;

  state = 0;

  while(1) {
    c = getchar();
    switch(state) {
    case 0:
      if (c=='/')      state = 1;     /* -> Zustand S1     */
      else if (c==EOF) exit(0);       /* Dateiende         */
      else             putchar(c);    /* Zeichen kopieren  */
      break;
    case 1:
      if (c=='*')      state = 2;     /* -> Zustand S2     */
      else if (c=='/') putchar('/');  /* altes '/'         */
      else if (c==EOF) {              /* Dateiende         */
        putchar('/');                 /* '/' noch ausgeben */
        exit(0);
      }
      else {
        putchar('/');                 /* altes '/'         */
        putchar(c);                   /* Zeichen kopieren  */
        state = 0;                    /* -> Zustand S0     */
      }
      break;
    case 2:
      if (c=='*')      state = 3;     /* -> Zustand S3     */
      else if (c==EOF) error();       /* Dateiende in Komm.*/
      break;
    case 3:
      if (c=='/')      state = 0;     /* -> Zustand S0     */
      else if (c==EOF) error();       /* Dateiende in Komm.*/
      else if (c!='*') state = 2;     /* -> Zustand S2     */
      break;
    }
  }

}
